#========================================================================================
# package      DE_EPAGES::Klarna::t::TestBaseOperation
# state        public
#----------------------------------------------------------------------------------------
# description  Unit tests for Klarna API BaseOperation
#========================================================================================
package TestBaseOperation;
use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::Klarna::API::KlarnaOperations::BaseOperation;
use Test::More;

sub Main {
    Test_BytePadding();
    Test_buildSecret();
    done_testing();
}
sub Test_BytePadding{
    _helper_BytePadding('YW55IGNhcm5hbCBwbGVhc3Vy','YW55IGNhcm5hbCBwbGVhc3Vy');
    _helper_BytePadding('YW55IGNhcm5hbCBwbGVhc3U' ,'YW55IGNhcm5hbCBwbGVhc3U=');
    _helper_BytePadding('YW55IGNhcm5hbCBwbGVhcw'  ,'YW55IGNhcm5hbCBwbGVhcw==');
    _helper_BytePadding('YW55IGNhcm5hbCBwbGVhc'  ,'YW55IGNhcm5hbCBwbGVhc');
    _helper_BytePadding('YW55IGNhcm5hbCBwbGVh'  ,'YW55IGNhcm5hbCBwbGVh=');

}
sub _helper_BytePadding{
    my $subTestName = (caller(0))[3];
    my ($Value,$ExpectedValue) = @_;
        my $Result =
        DE_EPAGES::Klarna::API::KlarnaOperations::BaseOperation->_Base64BytePadding($Value); ## no critic ( ProtectPrivateSubs )
        is ( $Result, $ExpectedValue, "$subTestName - check if $Value becomes $ExpectedValue - Result:$Result" );
}

sub Test_buildSecret {
    my $subTestName = (caller(0))[3];
     my $aValues = ['one','two'];
     my $EncrytedAndPaddedSecret =
     DE_EPAGES::Klarna::API::KlarnaOperations::BaseOperation->buildDigest($aValues); ## no critic ( ProtectPrivateSubs )
     my $ExpectedResult =  'zLTuwNMmb/zx9HyplkdTZg==';
     is($EncrytedAndPaddedSecret,$ExpectedResult,
        "$subTestName - is the Plain text encrypted and padded - $EncrytedAndPaddedSecret");
}
RunScript( Sub => \&Main );